<template>
  <div v-loading="isLoading" class="container mx-auto my-[37px]">
    <div
      class="grid grid-cols-3 mx-auto h-fit gap-x-[12px] gap-y-[24px] w-[1200px]"
    >
      <div
        v-for="promotion in promotions"
        :key="promotion"
        class="min-h-[380px]"
      >
        <promotion-vertical-card
          :promotion="promotion"
          :button-apply-promotion-enabled="buttonApplyPromotionEnabled"
          :authenticated="authenticated"
          :on-apply-promotion="onApplyPromotion"
          :is-processing="isProcessing"
          :is-applying="applyRequest.PromotionId === promotion.Id"
          :validate-lucky-wheelbutton="validateLuckyWheelbutton(promotion)"
          :on-click-spin-now="onClickSpinNow"
        />
      </div>
      <div
        v-if="promotions.length === 0"
        class="flex flex-col justify-center items-center my-[60px] col-span-3 overflow-hidden"
      >
        <div class="text-4xl text-center truncate no-data text-ellipsis">
          {{ $t("no_promotion_info") }}
        </div>
        <span class="font-bold text-lg fc-text">{{ assignHashText }}</span>
      </div>
    </div>
  </div>
</template>

<script lang="ts">
import { defineComponent } from "vue";

export default defineComponent({
  setup() {
    const {
      promotions,
      isDialogVisible,
      onMoreInformation,
      authenticated,
      promotionModel,
      isProcessing,
      onApplyPromotion,
      buttonApplyPromotionEnabled,
      assignHashText,
      isLoading,
      applyRequest,
      validateLuckyWheelbutton,
      onClickSpinNow,
    } = usePromotion();
    return {
      promotions,
      isDialogVisible,
      onMoreInformation,
      authenticated,
      promotionModel,
      isProcessing,
      onApplyPromotion,
      buttonApplyPromotionEnabled,
      assignHashText,
      isLoading,
      applyRequest,
      validateLuckyWheelbutton,
      onClickSpinNow,
    };
  },
});
</script>
